#include "stm32f4xx.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
#include "i2c.h"
#include "LiquidCrystal_PCF8574.h"
#define data_size 	5
#define CH6 		0x06

uint32_t gpio_pattern[data_size]={200,400,100,120,150};


#define AF01		0x01

char lcd_data[60];
uint16_t counter;

int main(void)
{

	i2c_init();
	lcd_init();
	lcd_clear();
	/*GPIO Configuration*/

	/*Enable clock access to GPIOA*/
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOCEN;

	/*Set PC0 to PC7 as output*/
	GPIOC->MODER|=GPIO_MODER_MODE0_0|GPIO_MODER_MODE1_0|GPIO_MODER_MODE2_0
			|GPIO_MODER_MODE3_0|GPIO_MODER_MODE4_0|GPIO_MODER_MODE5_0|
			GPIO_MODER_MODE6_0|GPIO_MODER_MODE7_0;

	GPIOC->MODER&=~(GPIO_MODER_MODE0_1|GPIO_MODER_MODE1_1|GPIO_MODER_MODE2_1
			|GPIO_MODER_MODE3_1|GPIO_MODER_MODE4_1|GPIO_MODER_MODE5_1
			|GPIO_MODER_MODE6_1|GPIO_MODER_MODE7_1);


	/*PA8 configuration*/

	/*Enable clock access to GPIOA*/
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;

	/*Set PA8 to AF*/
	GPIOA->MODER|=GPIO_MODER_MODE8_1;
	GPIOA->MODER&=~GPIO_MODER_MODE8_0;

	/*Set PA8 to AF1*/

	GPIOA->AFR[1]|=(AF01<<GPIO_AFRH_AFSEL8_Pos);


	/*Timer configuration*/

	RCC->APB2ENR  |=  RCC_APB2ENR_TIM1EN;

	TIM1->DIER=TIM_DIER_UDE;

	TIM1->PSC=16000-1; /*16 000 000 / 16 000 =1 000*/
	TIM1->ARR=1000-1; /*1 000 / 1 000 = 10HZ*/

	TIM1->CCR1=100;

	TIM1->CCMR1|=TIM_CCMR1_OC1M_2|TIM_CCMR1_OC1M_1;

	TIM1->CCER|=TIM_CCER_CC1E;

	TIM1->BDTR|=TIM_BDTR_MOE;

	/*DMA configuration*/


	RCC->AHB1ENR|=RCC_AHB1ENR_DMA2EN;

	DMA2_Stream5->CR&=DMA_SxCR_EN;

	while((DMA2_Stream5->CR)&DMA_SxCR_EN){;}

	DMA2_Stream5->CR|=(CH6<<DMA_SxCR_CHSEL_Pos)|DMA_SxCR_MSIZE|DMA_SxCR_PSIZE|
			DMA_SxCR_MINC|DMA_SxCR_CIRC|DMA_SxCR_DIR_0;

	DMA2_Stream5->NDTR=(uint32_t)data_size;

	DMA2_Stream5->PAR=(uint32_t)(&GPIOC->ODR);

	DMA2_Stream5->M0AR=(uint32_t)(gpio_pattern);


	/*Launch DMA*/
	DMA2_Stream5->CR|=DMA_SxCR_EN;

	/*Launch Timer*/
	TIM1->CR1     |= TIM_CR1_CEN;

	srand (TIM1->CNT);

	while(1)
	{
		sprintf(lcd_data,"Data to be send:");
		setCursor(0, 0);
		lcd_send_string(lcd_data);
		setCursor(0, 1);
		counter=5-((DMA2_Stream5->NDTR));
		sprintf(lcd_data,"%d   ",gpio_pattern[counter]);
		lcd_send_string(lcd_data);

	}

}
